/*
 * Ʈ: TLE2Framework
 * ϸ: UIConfiguration.java
 * ۼ: 2004. 10. 29
 */
package tle.framework.component.impl.uicreator.config;

import java.net.URL;
import java.util.List;
import java.util.Map;

import org.apache.commons.digester.Digester;
import org.apache.commons.digester.xmlrules.DigesterLoader;

import tle.framework.log.Logger;
import tle.framework.util.TLEConfigPathUtil;

/**
 *  Ͽ   Ѵ.
 * 
 * @author ֹ
 * @since 2.0
 */
public class UIConfiguration {
	private Map viewSetConfigMap = new java.util.HashMap();
	private Map commandConfigMap = new java.util.HashMap();
	private String defaultViewSetID;
	private Map clientMap = new java.util.HashMap();
	
	public void addViewSetConfig(ViewSetConfig viewSetConfig) {
		viewSetConfigMap.put(viewSetConfig.getViewSetID(), viewSetConfig);
	}
	public ViewSetConfig getViewSetConfig(String viewSetID) {
		return (ViewSetConfig)viewSetConfigMap.get(viewSetID);
	}
	public void addCommandConfig(CommandConfig commandConfig) {
		commandConfigMap.put(commandConfig.getCommandID(), commandConfig);
	}
	public void loadCommandMapping(String file) {
		try {
			URL ruleXml = UIConfigurationDigester.class.getClassLoader().getResource("tle/framework/component/impl/uicreator/config/UIConfiguration.cm.rule.xml");
			Digester digester = DigesterLoader.createDigester(ruleXml);
			List list = (List)digester.parse(TLEConfigPathUtil.replace(file));
			for (int i = 0 ; i < list.size() ; i++) {
				CommandConfig commandConfig = (CommandConfig)list.get(i);
				addCommandConfig(commandConfig);
			}
		} catch(Throwable e) {
			Logger.error("UIConfiguration.loadCommandMapping():"+e.getMessage(), e);
		}
	}
	public CommandConfig getCommandConfig(String commandID) {
		return (CommandConfig)commandConfigMap.get(commandID);
	}
	public void setDefaultViewSet(String viewSetID) {
		this.defaultViewSetID = viewSetID;
	}
	public ViewSetConfig getDefaultViewSetConfig() {
		return (ViewSetConfig)viewSetConfigMap.get(defaultViewSetID);
	}
	public void addClient(String clientType, String viewSetID) {
		clientMap.put(clientType, viewSetID);
	}
	public ViewSetConfig getClientViewSetConfig(String clientType) {
		String viewSetID = (String)clientMap.get(clientType);
		ViewSetConfig viewSet = (ViewSetConfig)viewSetConfigMap.get(viewSetID);
		if (viewSet == null) {
			viewSet = getDefaultViewSetConfig();
		}
		return viewSet;
	}
}
